gtkmm: Gtk::FlattenListModel Class Reference

gtkmm 4.14.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::FlattenListModel Class Reference
ListView Classes

A list model that flattens a list of lists. More...

`#include <gtkmm/flattenlistmodel.h>`

Inheritance diagram for Gtk::FlattenListModel:
[legend]

## Public Member Functions
| FlattenListModel (FlattenListModel &&src) noexcept
FlattenListModel & | operator= (FlattenListModel &&src) noexcept
| ~FlattenListModel () noexcept override
GtkFlattenListModel * | gobj ()
| Provides access to the underlying C GObject.
const GtkFlattenListModel * | gobj () const
| Provides access to the underlying C GObject.
GtkFlattenListModel * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | set_model (const Glib::RefPtr< Gio::ListModel > &model)
| Sets a new model to be flattened.
Glib::RefPtr< Gio::ListModel > | get_model ()
| Gets the model set via set_model().
Glib::RefPtr< const Gio::ListModel > | get_model () const
| Gets the model set via set_model().
Glib::RefPtr< Gio::ListModel > | get_model_for_item (guint position)
| Returns the model containing the item at the given position.
Glib::PropertyProxy_ReadOnly< GType > | property_item_type () const
| The type of items.
Glib::PropertyProxy< Glib::RefPtr< Gio::ListModel > > | property_model ()
| The model being flattened.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::ListModel > > | property_model () const
| The model being flattened.
Glib::PropertyProxy_ReadOnly< unsigned int > | property_n_items () const
| The number of items.

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< FlattenListModel > | create (const Glib::RefPtr< Gio::ListModel > &model)

## Protected Member Functions
| FlattenListModel (const Glib::RefPtr< Gio::ListModel > &model)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::FlattenListModel > | wrap (GtkFlattenListModel *object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

A list model that flattens a list of lists.

Gtk::FlattenListModel is a list model that takes a list model containing list models and flattens it into a single model.

Another term for this is concatenation: Gtk::FlattenListModel takes a list of lists and concatenates them into a single list.

See also
  Gio::ListModel

Since gtkmm 3.98

## Constructor & Destructor Documentation

## ◆ FlattenListModel() [1/2]

Gtk::FlattenListModel::FlattenListModel | ( | FlattenListModel && | src | ) |
| noexcept

## ◆ ~FlattenListModel()

Gtk::FlattenListModel::~FlattenListModel | ( |  | ) |
| overridenoexcept

## ◆ FlattenListModel() [2/2]

Gtk::FlattenListModel::FlattenListModel | ( | const Glib::RefPtr< Gio::ListModel > & | model | ) |
| explicitprotected

## Member Function Documentation

## ◆ create()

static Glib::RefPtr< FlattenListModel > Gtk::FlattenListModel::create | ( | const Glib::RefPtr< Gio::ListModel > & | model | ) |
| static

## ◆ get_model() [1/2]

Glib::RefPtr< Gio::ListModel > Gtk::FlattenListModel::get_model | ( |  | ) |

Gets the model set via set_model().

Returns
  The model flattened by self.

## ◆ get_model() [2/2]

Glib::RefPtr< const Gio::ListModel > Gtk::FlattenListModel::get_model | ( |  | ) | const

Gets the model set via set_model().

Returns
  The model flattened by self.

## ◆ get_model_for_item()

Glib::RefPtr< Gio::ListModel > Gtk::FlattenListModel::get_model_for_item | ( | guint | position | ) |

Returns the model containing the item at the given position.

Parameters

  position | A position.

Returns
  The model containing the item at position.

## ◆ get_type()

static GType Gtk::FlattenListModel::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkFlattenListModel * Gtk::FlattenListModel::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkFlattenListModel * Gtk::FlattenListModel::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkFlattenListModel * Gtk::FlattenListModel::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

FlattenListModel & Gtk::FlattenListModel::operator= | ( | FlattenListModel && | src | ) |
| noexcept

## ◆ property_item_type()

Glib::PropertyProxy_ReadOnly< GType > Gtk::FlattenListModel::property_item_type | ( |  | ) | const

The type of items.

See Gio::ListModel::get_item_type().

Since gtkmm 4.8

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_model() [1/2]

Glib::PropertyProxy< Glib::RefPtr< Gio::ListModel > > Gtk::FlattenListModel::property_model | ( |  | ) |

The model being flattened.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_model() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::ListModel > > Gtk::FlattenListModel::property_model | ( |  | ) | const

The model being flattened.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_n_items()

Glib::PropertyProxy_ReadOnly< unsigned int > Gtk::FlattenListModel::property_n_items | ( |  | ) | const

The number of items.

See Gio::ListModel::get_n_items().

Since gtkmm 4.8

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_model()

void Gtk::FlattenListModel::set_model | ( | const Glib::RefPtr< Gio::ListModel > & | model | ) |

Sets a new model to be flattened.

Parameters

  model | The new model.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::FlattenListModel > wrap | ( | GtkFlattenListModel * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.